﻿Imports System.Management
Imports System.IO
Imports System.Net
Public Class ProdKey

    Private _Key As String

#Region "Primary Entry Points"

    Public Sub New()
        GenKey()
    End Sub

    Public Function CheckIfLegal(ByVal AppPath As String, ByRef Expires As Boolean, ByRef ExDate As Date) As Boolean
        Try
            If Not File.Exists(AppPath & "\Licence.lic") Then
                Return False
            End If
            Dim Key = ReadFromLicenceFile(AppPath)
            If Not CheckUnlock(Key, Expires, ExDate) Then
                Return False
            End If
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function

    Public Function ActivateProduct(ByVal AppPath As String, ByVal Key As String, ByRef Expires As Boolean, ByRef ExDate As Date) As Boolean
        If Not CheckUnlock(Key, Expires, ExDate) Then
            Return False
        End If
        CreateLicenceFile(AppPath, Key)
        Return True
    End Function

    Public Function GenKey() As String
        Dim osInfo As OperatingSystem
        osInfo = System.Environment.OSVersion
        Dim HDDSerial As String = GetHardDriveInfo()
        Dim MAcSerial As String = GetMacAdresses()
        Dim OSID As String = osInfo.Version.ToString
        Dim Vals As String '30 char string containing the unencrypted Key

        'Example of a key
        Vals = "ProgID" & (HDDSerial.Trim & "MisingHD").ToString.Substring(0, 8)
        Vals = Vals & (OSID.Trim & "WinVerID").ToString.Substring(0, 8)
        Vals = Vals & (MAcSerial.Trim & "mac-addy").ToString.Substring(0, 8)

        Return (Getkey(Vals))
    End Function

    Public Function ValKey(ByVal Inkey As String) As String
        Dim Keys As String
        Keys = (Setkey(Inkey))

        Return Keys.Substring(0, 6) & " - " & Keys.Substring(6, 8) & " - " & Keys.Substring(14, 8) & " - " & Keys.Substring(22, 8)
    End Function

    Public Function GenUnlock(ByVal Inkey As String, ByVal Expire As Boolean, ByVal ExDate As Date) As String
        Dim Keys As String
        Dim Key1() As Byte = (Calk_Licen_Key(Inkey))
        Dim KeyDate() As Byte = Calk_Licen_Date(ExDate, Expire)

        Keys = (Calk_Unlock(KeyDate, Key1))
        If Keys.Length <> 14 Then
            Return ""
        End If
        Return Keys.Substring(0, 7) & "-" & Keys.Substring(7, 7)
    End Function

    Public Function CheckUnlock(ByVal Inkey As String, ByRef Expire As Boolean, ByRef ExDate As Date) As Boolean
        Inkey = Replace(Inkey, "-", "")
        Inkey = Replace(Inkey, " ", "")
        If Inkey Is Nothing Then Return False
        If Inkey.Length <> 14 Then
            Return False
        End If
        Dim MKey() As Byte = Get_Unlock(Inkey)
        Dim Keydate(4) As Byte
        Dim Key1() As Byte = Calk_Licen_Key(_Key)
        For tmpInt As Integer = 0 To 4
            Keydate(tmpInt) = MKey(tmpInt)
        Next
        ExDate = Get_Licen_Date(Keydate, Expire)
        For tmpInt As Integer = 0 To 8
            If Key1(tmpInt) <> MKey(tmpInt + 5) Then
                Return False
            End If
        Next
        Return True

    End Function
#End Region

#Region "Core_Functions"
    Private Function GetHardDriveInfo() As String
        GetHardDriveInfo = ""
        Try
            Dim strQuery As String = "SELECT * FROM Win32_PhysicalMedia"
            Dim query As ManagementObjectSearcher = New ManagementObjectSearcher(strQuery)
            Dim queryCollection As ManagementObjectCollection = query.Get()
            Dim mo As ManagementObject
            For Each mo In queryCollection
                GetHardDriveInfo = mo("SerialNumber").ToString()
                Exit For
            Next
        Catch ex As Exception
            'dispose of error
        Finally
            If GetHardDriveInfo = "" Then
                GetHardDriveInfo = "NOTFOUND"
            End If
        End Try
    End Function

    Private Function GetMacAdresses() As String
        Dim NetInterfaces() As NetworkInformation.NetworkInterface = NetworkInformation.NetworkInterface.GetAllNetworkInterfaces
        Dim MacList As New List(Of String)
        Dim MacAddress As String = ""
        Try

            For Each NetInterface As NetworkInformation.NetworkInterface In NetInterfaces
                If NetInterface.Description.ToUpper.Contains("NIC") Then
                    MacAddress = NetInterface.GetPhysicalAddress.ToString
                ElseIf MacAddress = "" AndAlso NetInterface.GetPhysicalAddress.ToString.Length = 12 Then
                    MacAddress = NetInterface.GetPhysicalAddress.ToString
                End If

            Next
        Catch ex As Exception
            'Dispose of error
        Finally
            If MacAddress = "" Then
                MacAddress = "NOTFOUND"
            End If

        End Try
        Return MacAddress
    End Function

    Private Function GetChar(ByVal SplitBits As Byte) As Byte
        Select Case SplitBits
            Case 0
                Return 56
            Case 1 To 26
                Return SplitBits Or 64
            Case 27 To 31
                Return (SplitBits And 7) Or 48
        End Select
    End Function

    Private Function SetChar(ByVal Chars As Byte) As Byte
        Select Case (Chars And 224)
            Case 32
                Select Case (Chars And 24)
                    Case 24
                        Select Case (Chars And 7)
                            Case 0
                                Return 0
                            Case Else
                                Return (Chars And 7) Or 16
                        End Select
                    Case 16
                        Select Case (Chars And 7)
                            Case 3 To 7
                                Return ((Chars And 7) Or 24)
                            Case Else
                                Return ((Chars And 7) Or 24)
                        End Select
                    Case 8
                        Return ((Chars And 7))
                    Case Else
                        Return (0)

                End Select
            Case 64, 96
                Return (Chars And 31)
        End Select
    End Function

    Private Function Fix(ByVal Chars As Byte) As Byte
        Select Case (Chars And 32)
            Case 32
                Return Chars
            Case 0
                Return (Chars Or 64)
        End Select
    End Function

    Private Function Getkey(ByVal InKey As String) As String
        If InKey.Length <> 30 Then
            Return ""
        End If

        Dim InChars(4) As Byte
        Dim OutChars(5) As Byte
        Dim KEY As String = ""
        For tmpInt As Integer = 0 To 29 Step 5
            For tmpint2 As Integer = 0 To 4
                InChars(tmpint2) = CByte(Asc(InKey.Substring(tmpInt + tmpint2, 1)))
            Next
            OutChars = GetShift(InChars)
            For tmpint2 As Integer = 0 To 5
                KEY = KEY & Chr(GetChar(OutChars(tmpint2)))
            Next
            If tmpInt < 25 Then
                KEY = KEY & "-"
            End If
        Next
        _Key = KEY 'save local copy ..
        Return KEY
    End Function

    Private Function Setkey(ByVal InKey As String) As String
        InKey = Replace(InKey, "-", "")
        If InKey.Length <> 36 Then
            Return ""
        End If

        Dim InChars(5) As Byte
        Dim OutChars(4) As Byte
        Dim KEY As String = ""
        For tmpInt As Integer = 0 To 35 Step 6
            For tmpint2 As Integer = 0 To 5
                InChars(tmpint2) = SetChar(CByte(Asc(InKey.Substring(tmpInt + tmpint2, 1))))
            Next
            OutChars = SetShift(InChars)
            For tmpint2 As Integer = 0 To 4
                KEY = KEY & Chr(Fix(OutChars(tmpint2)))
            Next
        Next
        Return KEY
    End Function

    Private Function GetShift(ByVal InChars() As Byte) As Byte()
        Dim OutChars(5) As Byte
        OutChars(0) = ((InChars(0) And 62) >> 1) And 31
        OutChars(1) = (((InChars(0) And 1) << 4) Or ((InChars(1) And 60) >> 2)) And 31
        OutChars(2) = (((InChars(1) And 3) << 3) Or ((InChars(2) And 56) >> 3)) And 31
        OutChars(3) = (((InChars(2) And 7) << 2) Or ((InChars(3) And 48) >> 4)) And 31
        OutChars(4) = (((InChars(3) And 15) << 1) Or ((InChars(4) And 32) >> 5)) And 31
        OutChars(5) = (InChars(4) And 31)
        Return OutChars
    End Function

    Private Function SetShift(ByVal InChars() As Byte) As Byte()
        Dim OutChars(4) As Byte
        OutChars(0) = (((InChars(0) And 31) << 1) Or ((InChars(1) And 16) >> 4)) And 63
        OutChars(1) = (((InChars(1) And 15) << 2) Or ((InChars(2) And 24) >> 3)) And 63
        OutChars(2) = (((InChars(2) And 7) << 3) Or ((InChars(3) And 28) >> 2)) And 63
        OutChars(3) = (((InChars(3) And 3) << 4) Or ((InChars(4) And 30) >> 1)) And 63
        OutChars(4) = (((InChars(4) And 1) << 5) Or (InChars(5) And 31)) And 63
        Return OutChars
    End Function

    Private Function Calk_Licen_Key(ByVal InKey As String) As Byte()
        Dim OutKey(0) As Byte
        InKey = Replace(InKey, "-", "")
        If InKey.Length <> 36 Then
            Return OutKey
        End If

        ReDim OutKey(8)
        For tmpInt As Integer = 0 To 8
            OutKey(tmpInt) = 0
        Next
        'Calculate a key here ..
        'Here is where the strength of the protection key is determined
        For tmpInt As Integer = 0 To 35 Step 9
            For tmpint2 As Integer = 0 To 8
                'Example of a calculation 
                Dim Inval As Byte = Asc(InKey.Substring(tmpInt + tmpint2, 1)) And 31 ' get the activation key char
                OutKey(tmpint2) = (OutKey(tmpint2) Xor Inval) And 31 ' Manipulate it using the current value of the Unlock Key
            Next
        Next
        Return OutKey
    End Function

    Private Function Calk_Licen_Date(ByVal Exdate As Date, ByVal expires As Boolean) As Byte()
        Dim OutKey(4) As Byte
        For tmpInt As Integer = 0 To 4
            OutKey(tmpInt) = 0
        Next
        'Outkey(0) contains a few bits of the current second so as to give a random key for encoding
        OutKey(0) = (Date.Now.Second And 28) Or ((CInt(Exdate.Year) >> 10) And 2) Or (expires And 1)
        OutKey(1) = (Exdate.Day And 31)
        OutKey(2) = ((CInt(Exdate.Year) >> 6) And 16) Or (Exdate.Month And 15)
        OutKey(3) = ((CInt(Exdate.Year) >> 5) And 31)
        OutKey(4) = ((CInt(Exdate.Year)) And 31)
        Return OutKey
    End Function

    Private Function Get_Licen_Date(ByVal Key As Byte(), ByRef expires As Boolean) As Date
        Dim Year As Integer
        Dim Month As Integer
        Dim Day As Integer
        Dim ExDate As Date

        Year = Key(4) Or ((Key(3) And 31) << 5) Or ((Key(2) And 16) << 6) Or ((Key(0) And 2) << 10)
        Month = Key(2) And 15
        Day = Key(1)
        expires = Key(0) And 1
        ExDate = Date.Now
        ExDate = ExDate.AddYears(Year - ExDate.Year).AddMonths(Month - ExDate.Month).AddDays(Day - ExDate.Day)
        Return ExDate

    End Function

    Private Function Calk_Unlock(ByVal Key1 As Byte(), ByVal Key2 As Byte()) As String
        If Key1.Length <> 5 Then
            Return ""
        End If
        If Key2.Length <> 9 Then
            Return ""
        End If
        Dim KEY As String = Chr(GetChar(Key1(0) And 31))
        For tmpInt As Integer = 1 To 4
            KEY = KEY & Chr(GetChar((Key1(tmpInt) Xor Key1(0)) And 31))
        Next
        For tmpInt As Integer = 0 To 8
            KEY = KEY & Chr(GetChar((Key2(tmpInt) Xor Key1(0)) And 31))
        Next
        Return KEY
    End Function

    Private Function Get_Unlock(ByVal Key As String) As Byte()
        Dim OutChar(0) As Byte

        If Key.Length <> 14 Then
            Return OutChar
        End If

        ReDim OutChar(13)

        OutChar(0) = SetChar(Asc(Key.Substring(0, 1)))
        For tmpInt As Integer = 1 To 13
            OutChar(tmpInt) = SetChar(Asc(Key.Substring(tmpInt, 1))) Xor OutChar(0)
        Next
        Return OutChar
    End Function
#End Region

#Region "File Functions"
    Private Function ReadFromLicenceFile(ByVal AppPath As String) As String
        ReadFromLicenceFile = My.Computer.FileSystem.ReadAllText(AppPath & "\Licence.lic")
    End Function

    Private Sub CreateLicenceFile(ByVal AppPath As String, ByVal code As String)
        File.WriteAllText(AppPath & "\Licence.lic", code)
    End Sub
#End Region

End Class
